
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class User_identitiesDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const user_identities = await db.user_identities.create(
            {
                id: data.id || undefined,
        
        external_subject: data.external_subject
        ||
        null
            ,
            
        external_email: data.external_email
        ||
        null
            ,
            
        display_name: data.display_name
        ||
        null
            ,
            
        linked_at: data.linked_at
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await user_identities.setUser( data.user || null, {
            transaction,
        });
        
        await user_identities.setIdentity_provider( data.identity_provider || null, {
            transaction,
        });
        
        await user_identities.setOrganizations( data.organizations || null, {
            transaction,
        });
        

        

        

        return user_identities;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const user_identitiesData = data.map((item, index) => ({
                id: item.id || undefined,
                
                external_subject: item.external_subject
            ||
            null
            ,
            
                external_email: item.external_email
            ||
            null
            ,
            
                display_name: item.display_name
            ||
            null
            ,
            
                linked_at: item.linked_at
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const user_identities = await db.user_identities.bulkCreate(user_identitiesData, { transaction });

        // For each item created, replace relation files
        

        return user_identities;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        const globalAccess = currentUser.app_role?.globalAccess;

        const user_identities = await db.user_identities.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.external_subject !== undefined) updatePayload.external_subject = data.external_subject;
        
        
        if (data.external_email !== undefined) updatePayload.external_email = data.external_email;
        
        
        if (data.display_name !== undefined) updatePayload.display_name = data.display_name;
        
        
        if (data.linked_at !== undefined) updatePayload.linked_at = data.linked_at;
        
        
        updatePayload.updatedById = currentUser.id;

        await user_identities.update(updatePayload, {transaction});

        
        
        if (data.user !== undefined) {
            await user_identities.setUser(
              
              data.user,
              
              { transaction }
            );
        }
        
        if (data.identity_provider !== undefined) {
            await user_identities.setIdentity_provider(
              
              data.identity_provider,
              
              { transaction }
            );
        }
        
        if (data.organizations !== undefined) {
            await user_identities.setOrganizations(
              
              data.organizations,
              
              { transaction }
            );
        }
        

        
        

        

        return user_identities;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const user_identities = await db.user_identities.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of user_identities) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of user_identities) {
                await record.destroy({transaction});
            }
        });


        return user_identities;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const user_identities = await db.user_identities.findByPk(id, options);

        await user_identities.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await user_identities.destroy({
            transaction
        });

        return user_identities;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const user_identities = await db.user_identities.findOne(
            { where },
            { transaction },
        );

        if (!user_identities) {
            return user_identities;
        }

        const output = user_identities.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.user = await user_identities.getUser({
            transaction
        });
        
        
        output.identity_provider = await user_identities.getIdentity_provider({
            transaction
        });
        
        
        output.organizations = await user_identities.getOrganizations({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           globalAccess,  options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        
        const user = (options && options.currentUser) || null;
        const userOrganizations = (user && user.organizations?.id) || null;
        

        
        if (userOrganizations) {
            if (options?.currentUser?.organizationsId) {
                where.organizationsId = options.currentUser.organizationsId;
            }
        }
        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.users,
        as: 'user',
        
        where: filter.user ? {
          [Op.or]: [
            { id: { [Op.in]: filter.user.split('|').map(term => Utils.uuid(term)) } },
            {
              firstName: {
                [Op.or]: filter.user.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.identity_providers,
        as: 'identity_provider',
        
        where: filter.identity_provider ? {
          [Op.or]: [
            { id: { [Op.in]: filter.identity_provider.split('|').map(term => Utils.uuid(term)) } },
            {
              name: {
                [Op.or]: filter.identity_provider.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.organizations,
        as: 'organizations',
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.external_subject) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'user_identities',
                        'external_subject',
                        filter.external_subject,
                    ),
                };
            }
            
            if (filter.external_email) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'user_identities',
                        'external_email',
                        filter.external_email,
                    ),
                };
            }
            
            if (filter.display_name) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'user_identities',
                        'display_name',
                        filter.display_name,
                    ),
                };
            }
            

            
            

            
            if (filter.linked_atRange) {
                const [start, end] = filter.linked_atRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    linked_at: {
                    ...where.linked_at,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    linked_at: {
                    ...where.linked_at,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            


      

      

      
      if (filter.organizations) {
        const listItems = filter.organizations.split('|').map(item => {
          return  Utils.uuid(item)
        });

        where = {
          ...where,
          organizationsId: {[Op.or]: listItems}
        };
      }
      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        
        if (globalAccess) {
            delete where.organizationsId;
        }
        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.user_identities.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset,  globalAccess, organizationId,) {
        let where = {};
        
        
        if (!globalAccess && organizationId) {
            where.organizationId = organizationId;
        }
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'user_identities',
                        'external_subject',
                        query,
                    ),
                ],
            };
        }

        const records = await db.user_identities.findAll({
            attributes: [ 'id', 'external_subject' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['external_subject', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.external_subject,
        }));
    }

    
};

